//LaserHulk.cs




//effects
datablock ParticleData(LaserHulkTrailParticle)
{
	  gravityCoefficient   = 0;
	dragCoefficient		= 5;
	windCoefficient		= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 400;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 100.0;
	spinRandomMin		= 50.0;
	spinRandomMax		= 150.0;
	useInvAlpha		= false;
	animateTexture		= false;

	textureName		= "./Spark3";

	//Interpolation variables
	colors[0]	= "0.0 1 0.1 1";
	colors[1]	= "0.0 1 0.2 1";
	colors[2]	= "0.0 1 0.3 1";

	sizes[0]	= 1;
	sizes[1]	= 0.4;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(LaserHulkTrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 1;
   ejectionVelocity = 0;
   ejectionOffset   = 0;
   velocityVariance = 0.0;
   thetaMin         = 90;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LaserHulkTrailParticle";
   uiName = "LaserHulkTrail";

};

//effects
datablock ParticleData(LaserHulkExplosionParticle)
{
   dragCoefficient      = 5;
   gravityCoefficient   = -0.1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
	spinSpeed		= 100.0;
	spinRandomMin		= 50.0;
	spinRandomMax		= 150.0;
	useInvAlpha		= false;
	animateTexture		= false;

	textureName		= "./Spark3";

	//Interpolation variables
	colors[0]	= "0.0 1 0.1 1";
	colors[1]	= "0.0 1 0.2 1";
	colors[2]	= "0.0 1 0.3 1";

	sizes[0]	= 3;
	sizes[1]	= 1.5;
	sizes[2]	= 0.00;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(LaserHulkExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 1;
   ejectionVelocity = 6;
   velocityVariance = 1.0;
   ejectionOffset   = 0.1;
   thetaMin         = 80;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LaserHulkExplosionParticle";

   uiName = "LaserHulk Hit";
};

datablock ExplosionData(LaserHulkExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;



   particleEmitter = LaserHulkExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.0;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.5 0.5 0.1";
   lightEndColor = "0 0 0";
};


//projectile
//AddDamageType("LaserHulk",   '<bitmap:add-ons/Weapon_LaserHulk/CI_LaserHulk> %1',    '%2 <bitmap:add-ons/Weapon_LaserHulk/CI_LaserHulk> %1',0.75,1);
datablock ProjectileData(LaserHulkProjectile)
{
   directDamage        = 40;
   //directDamageType  = $DamageType::LaserHulk;
  // radiusDamageType  = $DamageType::LaserHulk;
   explosion           = LaserHulkExplosion;
   particleEmitter     = LaserHulkTrailEmitter;


   muzzleVelocity      = 70;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 10000;
   fadeDelay           = 10000;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 1.0;
   lightColor = "0.5 0.5 0.1";

   uiName = "LaserHulk Laser";
};


//////////
// item //
//////////
datablock ItemData(LaserHulkItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
 shapeFile = "./LaserHulk.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "LaserHulk";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = LaserHulkImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(LaserHulkImage)
{
   // Basic Item properties
 shapeFile = "./LaserHulk.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0.35 0.3 -0.51";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = LaserHulkItem;
   ammo = " ";
   projectile = LaserHulkProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.25;
	stateTransitionOnTimeout[0]      = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;



	stateName[2]			= "PreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.1;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function LaserHulkImage::onFire(%this, %obj, %slot)
{

	Parent::onFire(%this, %obj, %slot);
}

function  LaserHulkImage::onUnMount(%this, %obj, %slot)
{	
%obj.unHideNode(Rhand);
%obj.unHideNode(Lhand);
}

function  LaserHulkImage::onMount(%this, %obj, %slot)
{	
%obj.HideNode(Rhand);
%obj.HideNode(Lhand);
}


